define(function (require) {

    var zrUtil = require('zrender.js/core/util');

    require('../coord/cartesian/Grid');

    require('./bar/BarSeries');
    require('./bar/BarView');

    var barLayoutGrid = require('../layout/barGrid');

    require('../echarts').registerLayout(zrUtil.curry(barLayoutGrid, 'bar'));
    // Visual coding for legend
    require('../echarts').registerVisualCoding('chart', function (ecModel) {
        ecModel.eachSeriesByType('bar', function (seriesModel) {
            var data = seriesModel.getData();
            data.setVisual('legendSymbol', 'roundRect');
        });
    });
});